require File.dirname(__FILE__) + '/../spec_helper.rb'
require 'jimpanzee/controller'

describe "JimpanzeeWindowAdapter" do
  def handler_method; end
  
  it "requires argument for the constructor" do
    lambda {Jimpanzee::JimpanzeeWindowAdapter.new()}.should raise_error(ArgumentError)
  end
  
  it "only allows existing methods to be defined" do
    lambda {Jimpanzee::JimpanzeeWindowAdapter.new(:someMadeUpMethod => nil)}.should raise_error(ArgumentError)
    lambda {Jimpanzee::JimpanzeeWindowAdapter.new(:windowClosing => method(:handler_method))}.should_not raise_error(ArgumentError)
  end
  
  it "requires a proc must be provided along with a valid method name" do
    lambda {Jimpanzee::JimpanzeeWindowAdapter.new(:windowClosing => nil)}.should raise_error(ArgumentError)
    lambda {Jimpanzee::JimpanzeeWindowAdapter.new(:windowClosing => method(:handler_method))}.should_not raise_error(ArgumentError)
  end
  
end